#pragma once
#include <States/GameState/Entities/Pacman/Pacman.h>
#include <States/GameState/Entities/StaticEntities/StaticEntities.h>
#include <States/GameState/Entities/DynamicEntities/DynamicEntities.h>

struct GameContext final {
    [[nodiscard]] GameContext clone() const;
    Pacman pacman;
    std::vector<std::unique_ptr<IStaticEntity>> static_objects;
    std::vector<std::unique_ptr<IDynamicEntity>> dynamic_objects;
    enum State{ BEGIN, INGAME, PAUSE, WIN, LOST} state = BEGIN;
};